#include "stdafx.h"
#include "BorderShape.h"

#include "ScriptletConstant.h"

REGISTER_COMPONENT_CREATOR(SCRIPTLET_BORDERSHAPE_NODE, CBorderShape);
IMPLEMENT_RTTI(CBorderShape, CDrawingShape)

class CBorderShapeLayout : public ILayoutManager
{
public:
	CBorderShapeLayout(CBorderShape* border)
	{
		m_Border = border;
	}
	void LayoutContainer( CContainer* pContainer )
	{
		m_Border->DoLayout(pContainer);
	}
private:
	CBorderShape* m_Border;
};

CBorderShape::CBorderShape()
{
	m_RsBg = new CRectangleShape();
	m_RsInner = new CRectangleShape();

	m_rcBorderDepth.SetRect(1, 1, 1, 1);

	m_RsBg->SetBackground(RGB(0x0, 0x0, 0x0));
	m_RsInner->SetBackground(RGB(0xff, 0xff, 0xff));

	this->Add(m_RsBg);
	this->Add(m_RsInner);

	ILayoutManager* layout = new CBorderShapeLayout(this);
	this->SetLayoutManager(layout);
	layout->Release();
}

CBorderShape::~CBorderShape()
{

}
void CBorderShape::DoLayout(CContainer* pContainer)
{
	CRect rcClient;
	pContainer->GetDrawingBounds(&rcClient);
	m_RsBg->SetActualBound(rcClient.left, rcClient.top , rcClient.Width(), rcClient.Height());
	this->_MoveRsInner();
}
void CBorderShape::SetBorderDepth( LPRECT prcBorderDepth )
{
	m_rcBorderDepth.CopyRect(prcBorderDepth);
	this->_MoveRsInner();
}

void CBorderShape::SetBorderDepth( int nBorderDepth )
{
	m_rcBorderDepth.SetRect(nBorderDepth, nBorderDepth, nBorderDepth, nBorderDepth);
	this->_MoveRsInner();
}

void CBorderShape::SetBorderColor( COLORREF clr )
{
	m_RsBg->SetBackground(clr);
}

void CBorderShape::SetInnerColor( COLORREF clr )
{
	m_RsInner->SetBackground(clr);
}

void CBorderShape::_MoveRsInner()
{
	CRect rcClient;
	this->GetDrawingBounds(&rcClient);
	rcClient.InflateRect(-m_rcBorderDepth.left, -m_rcBorderDepth.top, -m_rcBorderDepth.right, -m_rcBorderDepth.bottom);

	m_RsInner->SetActualBound(rcClient.left, rcClient.top , rcClient.Width(), rcClient.Height());
}